import asyncio
import signal

import discord


def serve(main, client: discord.Client, loop: asyncio.AbstractEventLoop):
    async def aclose():
        await client.change_presence(status=discord.Status.offline)
        await client.close()

    def close():
        loop.run_until_complete(aclose())

    def sigtermed(*_args):
        loop.create_task(aclose())

    signal.signal(signal.SIGTERM, sigtermed)
    try:
        loop.run_until_complete(main)
    except (KeyboardInterrupt, InterruptedError, RuntimeError):
        pass
    finally:
        if not client.is_closed():
            close()
